/*------------------------------------------------------------------------
 |  FILE            ClientCommands.java
 |  PART OF         SHH SpaceGame - a simple, networked multiplayer game.
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package client;

/**
 * Commands understood by game clients.
 *
 * @author    Sverre H. Huseby
 *            &lt;<A HREF="mailto:shh@thathost.com">shh@thathost.com</A>&gt;
 * @version   $Id: ClientCommands.java,v 1.2 2001/10/16 18:54:03 sverrehu Exp $
 */
public final class ClientCommands {
/*-----------------------------------------------------------------------+
 |  PUBLIC INTERFACE                                                     |
 +----------------------------------------------------------------------*/
    public static final byte GET_LOST               = -1;
    public static final byte SET_YOUR_ID            =  0;
    public static final byte NEW_PLAYER             =  1;
    public static final byte REMOVE_PLAYER          =  2;
    public static final byte SET_PLAYER_NAME        =  3;
    public static final byte SET_PLAYER_POSITION    =  4;
    public static final byte SET_PLAYER_SCORE       =  5;
    public static final byte SET_PLAYER_STATUS      =  6;
    public static final byte PLAYER_HIT             =  7;
    public static final byte PLAYER_DIES            =  8;
    public static final byte PLAYER_RESURRECTS      =  9;
    public static final byte NEW_STAR               = 10;
    public static final byte NEW_PHASER             = 11;
    public static final byte REMOVE_PHASER          = 12;
    public static final byte SET_PHASER_POSITION    = 13;
    public static final byte NEW_BOMB               = 14;
    public static final byte REMOVE_BOMB            = 15;
    public static final byte SET_BOMB_POSITION      = 16;
    public static final byte NEW_BOMB_PACK          = 17;
    public static final byte REMOVE_BOMB_PACK       = 18;
    public static final byte SET_BOMB_PACK_POSITION = 19;
    public static final byte NEW_EXPLOSION          = 20;
    public static final byte REMOVE_EXPLOSION       = 21;
    public static final byte SET_EXPLOSION_LEVEL    = 22;
    public static final byte PLAYER_SAYS            = 23;
}
