/*------------------------------------------------------------------------
 |  FILE            MainFuncProvider.java
 |  PART OF         SHH SpaceGame - a simple, networked multiplayer game.
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package client;

/**
 * Provides the functions in MainWin.java that are called from Client.java
 * and Board.java, so an applet implementation may implement them without
 * dealing with MainWin.java.
 *
 * @author    Sverre H. Huseby &lt;<A HREF="mailto:shh@thathost.com">
 *                                 shh@thathost.com</A>&gt;
 * @version   $Id: MainFuncProvider.java,v 1.2 2001/10/16 18:54:03 sverrehu Exp $
 */
public interface MainFuncProvider {
/*-----------------------------------------------------------------------+
|  PUBLIC INTERFACE                                                      |
+-----------------------------------------------------------------------*/
    public void doQuit();
    public void invokeChatLine();
}
