/*------------------------------------------------------------------------
 |  FILE            ReadmeDialog.java
 |  PART OF         SHH SpaceGame - a simple, networked multiplayer game.
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package gui;

import java.awt.*;

import no.shhsoft.awt.*;

/**
 *
 *
 * @author    Sverre H. Huseby
 *            &lt;<A HREF="mailto:shh@thathost.com">shh@thathost.com</A>&gt;
 * @version   $Id: ReadmeDialog.java,v 1.3 2002/01/27 14:47:32 sverrehu Exp $
 */
class ReadmeDialog {
/*-----------------------------------------------------------------------+
 |  PRIVATE PART                                                         |
 +----------------------------------------------------------------------*/
    private String   readme1 = ""
        + "SpaceGame - A Simple, Networked Multiplayer Game\n"
        + "================================================\n"
        + "\n"
        + "[This game is primarily written to be run as a Java application. You\n"
        + " may, however, also run it as an applet. See below for details.]\n"
        + "\n"
        + "This is a simple game for multiple players. It reminds a bit about the\n"
        + "good, old Asteroids arcade game, but there are no asteroids\n"
        + "here. Instead, there are other space ships, controlled by other\n"
        + "players. This game is useless for you if you either a) don't have any\n"
        + "friends, or b) don't have access to a computer network (modems may be\n"
        + "too slow). You may be able to find additional reasons for it's\n"
        + "uselessness.\n"
        + "\n"
        + "In your window, you see only a part of the world. Your ship stays\n"
        + "centered in the view all the time. In the lower right corner is a\n"
        + "radar display showing the entire world. A gray rectangle marks the\n"
        + "area of the world you currently have in your window. Enemy ships\n"
        + "appear in the radar as green dots, while weapons left by dying enemies\n"
        + "are shown as red dots.\n"
        + "\n"
        + "You ship's status is shown in the lower left corner. A ship damage\n"
        + "meter shows how far you are from being blown completely away. If this\n"
        + "meter goes high, you should bail out of any battle you attend to, and\n"
        + "spend some time on you own. The ship will then slowly repair\n"
        + "itself. There is also a bomb count in the lower left corner, along\n"
        + "with a phaser temperature meter.\n"
        + "\n"
        + "Which brings us to the weapon systems. There are two weapons\n"
        + "available. The phaser, of which you have an unlimited supply, fire in\n"
        + "the direction of you ship's nose. Multiple phaser hits are needed to\n"
        + "take out an enemy. Note that the phaser cannon tends to go warm after\n"
        + "intensive shooting. When it overheats, it will no longer work, and\n"
        + "you'll have to wait for a while for the cannon to cool down.\n"
        + "Initially, your ship is also equipped with a few smart, targeting\n"
        + "bombs. These shoot-and-forget missiles will follow your closest enemy\n"
        + "until they run out of fuel. Two to three bombs are required to destroy\n"
        + "a fully functional enemy ship.\n"
        + "\n"
        + "If your ship is destroyed while you still have bombs left, the\n"
        + "remaining bombs are left for others to pick up.\n"
        + "\n"
        + "When you die, and you certainly will if you play this game for a\n"
        + "while, you may resurrect by pressing any of the fire buttons.\n"
        + "\n"
        + "The upper right corner of the window shows the score table. The score\n"
        + "is based on a ratio from the number of kills over the number of times\n"
        + "a player has been killed (the two numbers are given in parenthesis).\n"
        + "\n"
        + "\n"
        + "Steering Around\n"
        + "---------------\n"
        + "\n"
        + "The following keys are used to operate the ship: (If you forget, you\n"
        + "may press and hold F1 while playing, to have a similar list popped\n"
        + "up.)\n"
        + "\n"
        + "    Up arrow           Move forward. Forward is the current direction\n"
        + "                       of the ship's nose.\n"
        + "    Down arrow         Reverse engine.\n"
        + "    Left arrow         Turn left.\n"
        + "    Right arrow        Turn right.\n"
        + "\n"
        + "    Ctrl or Space      Fire Phaser. Also: New ship after dying.\n"
        + "    Tab                Fire targeting bomb.\n"
        + "\n"
        + "    A                  Toggle audio.\n"
        + "    S                  Toggle displaying score table.\n"
        + "    T                  Enable entering a line of text that will be\n"
        + "                       passed to all players. The line is sent when\n"
        + "                       you press return.\n"
        + "\n"
        + "    F1                 Help on keys (only visible as long as you hold\n"
        + "                       F1 down).\n"
        + "\n"
        + "\n";
    private String   readme2 = ""
        + "Starting to Play\n"
        + "----------------\n"
        + "\n"
        + "Please see the file INSTALL.txt for general notes on how to set up and\n"
        + "run Java programs before reading any further.\n"
        + "\n"
        + "NOTE:   Users of M$ Windows may have to resize the game window by\n"
        + "        extending the height of the window according to the height of\n"
        + "        the menu bar. This is due to a bug in older (pre 1.1.6)\n"
        + "        versions of Java on Windows.\n"
        + "\n"
        + "NOTE 2: You may wish to give your Java Virtual Machine (JVM) the option\n"
        + "        -noasyncgc in order to avoid occasional short delays. If this\n"
        + "        doesn't mean anything to you, don't scratch your head, just\n"
        + "        ignore this.\n"
        + "\n"
        + "One of the players must set up a game server. The server controls the\n"
        + "entire game (in this program, very little is left to the clients). You\n"
        + "may set up a server in any of two ways:\n"
        + "\n"
        + "1. Start a server as part of your running SpaceGame. You do this by\n"
        + "   choosing \"Set up Local Server\" on the \"Game\" menu. There should be\n"
        + "   no need to use a port other than the default (9998), unless you get\n"
        + "   error messages. In that case, pick a port number that is > 1024.\n"
        + "   When the server is set up, a client will automatically be set up\n"
        + "   for you, and get connected to your server.\n"
        + "\n"
        + "2. Use a dedicated server. This is a version of SpaceGame running only\n"
        + "   as a server. To set up a dedicated server, you must pass the option\n"
        + "   \"-server\" on the command line to SpaceGame. No window will be\n"
        + "   created, and the server will be running until it is brutally\n"
        + "   killed. You may also specify which port the server should use. Use\n"
        + "   the option \"-help\" to see how to do this.\n"
        + "\n"
        + "All other players must connect to the server by choosing \"Connect to\n"
        + "Remote Server\" on the \"Game\" menu. The hostname should be the network\n"
        + "name of the computer running the server, and the port should be the\n"
        + "same number as the one used on the server.\n"
        + "\n"
        + "You should also invoke \"Identity\" on the \"Game\" menu to give your\n"
        + "player a name. If you don't, your name will be \"Player\", and no one\n"
        + "will know who you are. If you're an awfully poor player, or an\n"
        + "extremely good one, you may not want to enter your name here.\n"
        + "\n"
        + "Any changes you do to the dialogs described in this section, are saved\n"
        + "and used the next time you start the program.\n"
        + "\n"
        + "It seems that most of the CPU time in this program is spent by the\n"
        + "window system drawing and displaying the game board. If you have a\n"
        + "slow computer (486) and/or a slow graphics card, you may try to reduce\n"
        + "the visible game area by using the -scale option when you start the\n"
        + "program. The parameter to -scale is a number between 30 and 100,\n"
        + "giving the reduction of the board width and height in percent. Note\n"
        + "that this will give you a narrower view of the world than the rest of\n"
        + "the players, unless you all agree on reducing the size of the visible\n"
        + "area.\n"
        + "\n"
        + "\n"
        + "Providing SpaceGame as An Applet\n"
        + "--------------------------------\n"
        + "\n"
        + "The file SpaceGameApplet.jar contains the parts of SpaceGame that is\n"
        + "needed for running the game as an applet in a Java 1.1 compatible Web\n"
        + "Browser. To be able to provide SpaceGame as an applet, you will need\n"
        + "to set up a SpaceGame server on _the_same_machine_ that the Web server\n"
        + "is running on. This is due to restrictions placed on applets for\n"
        + "security reasons: Normally applets are not allowed to open network\n"
        + "connections to other machines than the ones they were downloaded from.\n"
        + "\n"
        + "To include the applet in a Web page, include an APPLET tag like the\n"
        + "one below (also see sample.html):\n"
        + "\n"
        + "     <APPLET CODEBASE=\"/url/to/directory/of/the/jar-file/\"\n"
        + "             ARCHIVE=\"SpaceGameApplet.jar\"\n"
        + "             CODE=\"SpaceGameApplet.class\"\n"
        + "             WIDTH=600 HEIGHT=471>\n"
        + "         <PARAM NAME=\"host\" VALUE=\"the.spacegame.server.com\">\n"
        + "         <PARAM NAME=\"port\" VALUE=\"9998\">\n"
        + "       Your browser doesn't support Java applets. Sorry.\n"
        + "     </APPLET>\n"
        + "\n"
        + "You may, and probably should, leave the PARAM-tags out. If you don't\n"
        + "specify a host parameter, the default is to use the host from which\n"
        + "the applet was loaded, which is probably what you want anyway. If you\n"
        + "omit the port number, 9998 is used. This is the default for the\n"
        + "server as well.\n"
        + "\n"
        + "Note that Netscape Navigator is not particularly good at loading\n"
        + "resources from JAR-files, so you won't get any sound with this\n"
        + "browser.\n"
        + "\n"
        + "\n"
        + "Author\n"
        + "------\n"
        + "\n"
        + "The program is written by\n"
        + "\n"
        + "        Sverre H. Huseby     shh@thathost.com\n"
        + "        Kurvn. 30            http://home.sol.no/~sverrehu/\n"
        + "        N-0495 Oslo\n"
        + "        Norway\n"
        + "\n"
        + "You can use and copy this for _free_, but I would be very happy if you\n"
        + "send me an E-mail and tell me that you use it. If you insist on paying\n"
        + "something, please donate some money to an organization that strives to\n"
        + "make the world a better place for everyone.\n"
        + "\n"
        + "I don't like bugs, so please help me removing them by reporting\n"
        + "whatever you find!\n"
        ;

    /* this stupid splitting is needed because my Linux JDK 1.1.3 had
     * problem with all this string concatenation. */
    private String readme = readme1 + readme2;

    private Panel setupPanel() {
        Panel    panel;
        TextArea text;

        panel = new Panel(new BorderLayout());

        text = new TextArea(readme, 30, 80, TextArea.SCROLLBARS_VERTICAL_ONLY);
        text.setFont(new Font("Courier", Font.PLAIN, 12));
        text.setEditable(false);
        panel.add(text);

        return panel;
    }

/*-----------------------------------------------------------------------+
 |  PUBLIC INTERFACE                                                     |
 +----------------------------------------------------------------------*/
    public ReadmeDialog(Frame parent) {
        ModalButtonDialog dlg;

        dlg = new ModalButtonDialog(parent, "README.txt", setupPanel(),
                                    ModalButtonDialog.CLOSE,
                                    ModalButtonDialog.CLOSE);
        dlg.show();
    }
}
